<a id="mypy-boto3-pinpoint"></a>

# mypy-boto3-pinpoint

[![PyPI - mypy-boto3-pinpoint](https://img.shields.io/pypi/v/mypy-boto3-pinpoint.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-pinpoint.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-pinpoint?color=blue)](https://pypistats.org/packages/mypy-boto3-pinpoint)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.Pinpoint 1.17.101](https://boto3.amazonaws.com/v1/documentation/api/1.17.101/reference/services/pinpoint.html#Pinpoint)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.20.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-pinpoint docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_pinpoint/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-pinpoint](#mypy-boto3-pinpoint)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `Pinpoint` service.

```bash
python -m pip install boto3-stubs[pinpoint]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[pinpoint]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint]'`

Both type checking and auto-complete should work for `Pinpoint` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[pinpoint]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint]'`

Both type checking and auto-complete should work for `Pinpoint` service. No
explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[pinpoint]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint]'`
- Run `mypy` as usual

Type checking should work for `Pinpoint` service. No explicit type annotations
required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[pinpoint]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `Pinpoint` service. No explicit type annotations
required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`PinpointClient` provides annotations for `boto3.client("pinpoint")`.

```python
import boto3

from mypy_boto3_pinpoint import PinpointClient

client: PinpointClient = boto3.client("pinpoint")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: PinpointClient = session.client("pinpoint")
```

<a id="literals"></a>

### Literals

`mypy_boto3_pinpoint.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_pinpoint.literals import (
    ActionType,
    AttributeTypeType,
    CampaignStatusType,
    ChannelTypeType,
    DeliveryStatusType,
    DimensionTypeType,
    DurationType,
    FilterTypeType,
    FormatType,
    FrequencyType,
    IncludeType,
    JobStatusType,
    MessageTypeType,
    ModeType,
    OperatorType,
    RecencyTypeType,
    SegmentTypeType,
    SourceTypeType,
    StateType,
    TemplateTypeType,
    TypeType,
    __EndpointTypesElementType,
)

def check_value(value: ActionType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_pinpoint.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_pinpoint.type_defs import (
    ADMChannelRequestTypeDef,
    ADMChannelResponseTypeDef,
    ADMMessageTypeDef,
    APNSChannelRequestTypeDef,
    APNSChannelResponseTypeDef,
    APNSMessageTypeDef,
    APNSPushNotificationTemplateTypeDef,
    APNSSandboxChannelRequestTypeDef,
    APNSSandboxChannelResponseTypeDef,
    APNSVoipChannelRequestTypeDef,
    APNSVoipChannelResponseTypeDef,
    APNSVoipSandboxChannelRequestTypeDef,
    APNSVoipSandboxChannelResponseTypeDef,
    ActivitiesResponseTypeDef,
    ActivityResponseTypeDef,
    ActivityTypeDef,
    AddressConfigurationTypeDef,
    AndroidPushNotificationTemplateTypeDef,
    ApplicationDateRangeKpiResponseTypeDef,
    ApplicationResponseTypeDef,
    ApplicationSettingsResourceTypeDef,
    ApplicationsResponseTypeDef,
    AttributeDimensionTypeDef,
    AttributesResourceTypeDef,
    BaiduChannelRequestTypeDef,
    BaiduChannelResponseTypeDef,
    BaiduMessageTypeDef,
    BaseKpiResultTypeDef,
    CampaignCustomMessageTypeDef,
    CampaignDateRangeKpiResponseTypeDef,
    CampaignEmailMessageTypeDef,
    CampaignEventFilterTypeDef,
    CampaignHookTypeDef,
    CampaignLimitsTypeDef,
    CampaignResponseTypeDef,
    CampaignSmsMessageTypeDef,
    CampaignStateTypeDef,
    CampaignsResponseTypeDef,
    ChannelResponseTypeDef,
    ChannelsResponseTypeDef,
    ConditionTypeDef,
    ConditionalSplitActivityTypeDef,
    CreateAppRequestTypeDef,
    CreateAppResponseResponseTypeDef,
    CreateApplicationRequestTypeDef,
    CreateCampaignRequestTypeDef,
    CreateCampaignResponseResponseTypeDef,
    CreateEmailTemplateRequestTypeDef,
    CreateEmailTemplateResponseResponseTypeDef,
    CreateExportJobRequestTypeDef,
    CreateExportJobResponseResponseTypeDef,
    CreateImportJobRequestTypeDef,
    CreateImportJobResponseResponseTypeDef,
    CreateJourneyRequestTypeDef,
    CreateJourneyResponseResponseTypeDef,
    CreatePushTemplateRequestTypeDef,
    CreatePushTemplateResponseResponseTypeDef,
    CreateRecommenderConfigurationRequestTypeDef,
    CreateRecommenderConfigurationResponseResponseTypeDef,
    CreateRecommenderConfigurationTypeDef,
    CreateSegmentRequestTypeDef,
    CreateSegmentResponseResponseTypeDef,
    CreateSmsTemplateRequestTypeDef,
    CreateSmsTemplateResponseResponseTypeDef,
    CreateTemplateMessageBodyTypeDef,
    CreateVoiceTemplateRequestTypeDef,
    CreateVoiceTemplateResponseResponseTypeDef,
    CustomDeliveryConfigurationTypeDef,
    CustomMessageActivityTypeDef,
    DefaultMessageTypeDef,
    DefaultPushNotificationMessageTypeDef,
    DefaultPushNotificationTemplateTypeDef,
    DeleteAdmChannelRequestTypeDef,
    DeleteAdmChannelResponseResponseTypeDef,
    DeleteApnsChannelRequestTypeDef,
    DeleteApnsChannelResponseResponseTypeDef,
    DeleteApnsSandboxChannelRequestTypeDef,
    DeleteApnsSandboxChannelResponseResponseTypeDef,
    DeleteApnsVoipChannelRequestTypeDef,
    DeleteApnsVoipChannelResponseResponseTypeDef,
    DeleteApnsVoipSandboxChannelRequestTypeDef,
    DeleteApnsVoipSandboxChannelResponseResponseTypeDef,
    DeleteAppRequestTypeDef,
    DeleteAppResponseResponseTypeDef,
    DeleteBaiduChannelRequestTypeDef,
    DeleteBaiduChannelResponseResponseTypeDef,
    DeleteCampaignRequestTypeDef,
    DeleteCampaignResponseResponseTypeDef,
    DeleteEmailChannelRequestTypeDef,
    DeleteEmailChannelResponseResponseTypeDef,
    DeleteEmailTemplateRequestTypeDef,
    DeleteEmailTemplateResponseResponseTypeDef,
    DeleteEndpointRequestTypeDef,
    DeleteEndpointResponseResponseTypeDef,
    DeleteEventStreamRequestTypeDef,
    DeleteEventStreamResponseResponseTypeDef,
    DeleteGcmChannelRequestTypeDef,
    DeleteGcmChannelResponseResponseTypeDef,
    DeleteJourneyRequestTypeDef,
    DeleteJourneyResponseResponseTypeDef,
    DeletePushTemplateRequestTypeDef,
    DeletePushTemplateResponseResponseTypeDef,
    DeleteRecommenderConfigurationRequestTypeDef,
    DeleteRecommenderConfigurationResponseResponseTypeDef,
    DeleteSegmentRequestTypeDef,
    DeleteSegmentResponseResponseTypeDef,
    DeleteSmsChannelRequestTypeDef,
    DeleteSmsChannelResponseResponseTypeDef,
    DeleteSmsTemplateRequestTypeDef,
    DeleteSmsTemplateResponseResponseTypeDef,
    DeleteUserEndpointsRequestTypeDef,
    DeleteUserEndpointsResponseResponseTypeDef,
    DeleteVoiceChannelRequestTypeDef,
    DeleteVoiceChannelResponseResponseTypeDef,
    DeleteVoiceTemplateRequestTypeDef,
    DeleteVoiceTemplateResponseResponseTypeDef,
    DirectMessageConfigurationTypeDef,
    EmailChannelRequestTypeDef,
    EmailChannelResponseTypeDef,
    EmailMessageActivityTypeDef,
    EmailMessageTypeDef,
    EmailTemplateRequestTypeDef,
    EmailTemplateResponseTypeDef,
    EndpointBatchItemTypeDef,
    EndpointBatchRequestTypeDef,
    EndpointDemographicTypeDef,
    EndpointItemResponseTypeDef,
    EndpointLocationTypeDef,
    EndpointMessageResultTypeDef,
    EndpointRequestTypeDef,
    EndpointResponseTypeDef,
    EndpointSendConfigurationTypeDef,
    EndpointUserTypeDef,
    EndpointsResponseTypeDef,
    EventConditionTypeDef,
    EventDimensionsTypeDef,
    EventFilterTypeDef,
    EventItemResponseTypeDef,
    EventStartConditionTypeDef,
    EventStreamTypeDef,
    EventTypeDef,
    EventsBatchTypeDef,
    EventsRequestTypeDef,
    EventsResponseTypeDef,
    ExportJobRequestTypeDef,
    ExportJobResourceTypeDef,
    ExportJobResponseTypeDef,
    ExportJobsResponseTypeDef,
    GCMChannelRequestTypeDef,
    GCMChannelResponseTypeDef,
    GCMMessageTypeDef,
    GPSCoordinatesTypeDef,
    GPSPointDimensionTypeDef,
    GetAdmChannelRequestTypeDef,
    GetAdmChannelResponseResponseTypeDef,
    GetApnsChannelRequestTypeDef,
    GetApnsChannelResponseResponseTypeDef,
    GetApnsSandboxChannelRequestTypeDef,
    GetApnsSandboxChannelResponseResponseTypeDef,
    GetApnsVoipChannelRequestTypeDef,
    GetApnsVoipChannelResponseResponseTypeDef,
    GetApnsVoipSandboxChannelRequestTypeDef,
    GetApnsVoipSandboxChannelResponseResponseTypeDef,
    GetAppRequestTypeDef,
    GetAppResponseResponseTypeDef,
    GetApplicationDateRangeKpiRequestTypeDef,
    GetApplicationDateRangeKpiResponseResponseTypeDef,
    GetApplicationSettingsRequestTypeDef,
    GetApplicationSettingsResponseResponseTypeDef,
    GetAppsRequestTypeDef,
    GetAppsResponseResponseTypeDef,
    GetBaiduChannelRequestTypeDef,
    GetBaiduChannelResponseResponseTypeDef,
    GetCampaignActivitiesRequestTypeDef,
    GetCampaignActivitiesResponseResponseTypeDef,
    GetCampaignDateRangeKpiRequestTypeDef,
    GetCampaignDateRangeKpiResponseResponseTypeDef,
    GetCampaignRequestTypeDef,
    GetCampaignResponseResponseTypeDef,
    GetCampaignVersionRequestTypeDef,
    GetCampaignVersionResponseResponseTypeDef,
    GetCampaignVersionsRequestTypeDef,
    GetCampaignVersionsResponseResponseTypeDef,
    GetCampaignsRequestTypeDef,
    GetCampaignsResponseResponseTypeDef,
    GetChannelsRequestTypeDef,
    GetChannelsResponseResponseTypeDef,
    GetEmailChannelRequestTypeDef,
    GetEmailChannelResponseResponseTypeDef,
    GetEmailTemplateRequestTypeDef,
    GetEmailTemplateResponseResponseTypeDef,
    GetEndpointRequestTypeDef,
    GetEndpointResponseResponseTypeDef,
    GetEventStreamRequestTypeDef,
    GetEventStreamResponseResponseTypeDef,
    GetExportJobRequestTypeDef,
    GetExportJobResponseResponseTypeDef,
    GetExportJobsRequestTypeDef,
    GetExportJobsResponseResponseTypeDef,
    GetGcmChannelRequestTypeDef,
    GetGcmChannelResponseResponseTypeDef,
    GetImportJobRequestTypeDef,
    GetImportJobResponseResponseTypeDef,
    GetImportJobsRequestTypeDef,
    GetImportJobsResponseResponseTypeDef,
    GetJourneyDateRangeKpiRequestTypeDef,
    GetJourneyDateRangeKpiResponseResponseTypeDef,
    GetJourneyExecutionActivityMetricsRequestTypeDef,
    GetJourneyExecutionActivityMetricsResponseResponseTypeDef,
    GetJourneyExecutionMetricsRequestTypeDef,
    GetJourneyExecutionMetricsResponseResponseTypeDef,
    GetJourneyRequestTypeDef,
    GetJourneyResponseResponseTypeDef,
    GetPushTemplateRequestTypeDef,
    GetPushTemplateResponseResponseTypeDef,
    GetRecommenderConfigurationRequestTypeDef,
    GetRecommenderConfigurationResponseResponseTypeDef,
    GetRecommenderConfigurationsRequestTypeDef,
    GetRecommenderConfigurationsResponseResponseTypeDef,
    GetSegmentExportJobsRequestTypeDef,
    GetSegmentExportJobsResponseResponseTypeDef,
    GetSegmentImportJobsRequestTypeDef,
    GetSegmentImportJobsResponseResponseTypeDef,
    GetSegmentRequestTypeDef,
    GetSegmentResponseResponseTypeDef,
    GetSegmentVersionRequestTypeDef,
    GetSegmentVersionResponseResponseTypeDef,
    GetSegmentVersionsRequestTypeDef,
    GetSegmentVersionsResponseResponseTypeDef,
    GetSegmentsRequestTypeDef,
    GetSegmentsResponseResponseTypeDef,
    GetSmsChannelRequestTypeDef,
    GetSmsChannelResponseResponseTypeDef,
    GetSmsTemplateRequestTypeDef,
    GetSmsTemplateResponseResponseTypeDef,
    GetUserEndpointsRequestTypeDef,
    GetUserEndpointsResponseResponseTypeDef,
    GetVoiceChannelRequestTypeDef,
    GetVoiceChannelResponseResponseTypeDef,
    GetVoiceTemplateRequestTypeDef,
    GetVoiceTemplateResponseResponseTypeDef,
    HoldoutActivityTypeDef,
    ImportJobRequestTypeDef,
    ImportJobResourceTypeDef,
    ImportJobResponseTypeDef,
    ImportJobsResponseTypeDef,
    ItemResponseTypeDef,
    JourneyCustomMessageTypeDef,
    JourneyDateRangeKpiResponseTypeDef,
    JourneyEmailMessageTypeDef,
    JourneyExecutionActivityMetricsResponseTypeDef,
    JourneyExecutionMetricsResponseTypeDef,
    JourneyLimitsTypeDef,
    JourneyPushMessageTypeDef,
    JourneyResponseTypeDef,
    JourneySMSMessageTypeDef,
    JourneyScheduleTypeDef,
    JourneyStateRequestTypeDef,
    JourneysResponseTypeDef,
    ListJourneysRequestTypeDef,
    ListJourneysResponseResponseTypeDef,
    ListRecommenderConfigurationsResponseTypeDef,
    ListTagsForResourceRequestTypeDef,
    ListTagsForResourceResponseResponseTypeDef,
    ListTemplateVersionsRequestTypeDef,
    ListTemplateVersionsResponseResponseTypeDef,
    ListTemplatesRequestTypeDef,
    ListTemplatesResponseResponseTypeDef,
    MessageBodyTypeDef,
    MessageConfigurationTypeDef,
    MessageRequestTypeDef,
    MessageResponseTypeDef,
    MessageResultTypeDef,
    MessageTypeDef,
    MetricDimensionTypeDef,
    MultiConditionalBranchTypeDef,
    MultiConditionalSplitActivityTypeDef,
    NumberValidateRequestTypeDef,
    NumberValidateResponseTypeDef,
    PhoneNumberValidateRequestTypeDef,
    PhoneNumberValidateResponseResponseTypeDef,
    PublicEndpointTypeDef,
    PushMessageActivityTypeDef,
    PushNotificationTemplateRequestTypeDef,
    PushNotificationTemplateResponseTypeDef,
    PutEventStreamRequestTypeDef,
    PutEventStreamResponseResponseTypeDef,
    PutEventsRequestTypeDef,
    PutEventsResponseResponseTypeDef,
    QuietTimeTypeDef,
    RandomSplitActivityTypeDef,
    RandomSplitEntryTypeDef,
    RawEmailTypeDef,
    RecencyDimensionTypeDef,
    RecommenderConfigurationResponseTypeDef,
    RemoveAttributesRequestTypeDef,
    RemoveAttributesResponseResponseTypeDef,
    ResponseMetadataTypeDef,
    ResultRowTypeDef,
    ResultRowValueTypeDef,
    SMSChannelRequestTypeDef,
    SMSChannelResponseTypeDef,
    SMSMessageActivityTypeDef,
    SMSMessageTypeDef,
    SMSTemplateRequestTypeDef,
    SMSTemplateResponseTypeDef,
    ScheduleTypeDef,
    SegmentBehaviorsTypeDef,
    SegmentConditionTypeDef,
    SegmentDemographicsTypeDef,
    SegmentDimensionsTypeDef,
    SegmentGroupListTypeDef,
    SegmentGroupTypeDef,
    SegmentImportResourceTypeDef,
    SegmentLocationTypeDef,
    SegmentReferenceTypeDef,
    SegmentResponseTypeDef,
    SegmentsResponseTypeDef,
    SendMessagesRequestTypeDef,
    SendMessagesResponseResponseTypeDef,
    SendUsersMessageRequestTypeDef,
    SendUsersMessageResponseTypeDef,
    SendUsersMessagesRequestTypeDef,
    SendUsersMessagesResponseResponseTypeDef,
    SessionTypeDef,
    SetDimensionTypeDef,
    SimpleConditionTypeDef,
    SimpleEmailPartTypeDef,
    SimpleEmailTypeDef,
    StartConditionTypeDef,
    TagResourceRequestTypeDef,
    TagsModelTypeDef,
    TemplateActiveVersionRequestTypeDef,
    TemplateConfigurationTypeDef,
    TemplateResponseTypeDef,
    TemplateTypeDef,
    TemplateVersionResponseTypeDef,
    TemplateVersionsResponseTypeDef,
    TemplatesResponseTypeDef,
    TreatmentResourceTypeDef,
    UntagResourceRequestTypeDef,
    UpdateAdmChannelRequestTypeDef,
    UpdateAdmChannelResponseResponseTypeDef,
    UpdateApnsChannelRequestTypeDef,
    UpdateApnsChannelResponseResponseTypeDef,
    UpdateApnsSandboxChannelRequestTypeDef,
    UpdateApnsSandboxChannelResponseResponseTypeDef,
    UpdateApnsVoipChannelRequestTypeDef,
    UpdateApnsVoipChannelResponseResponseTypeDef,
    UpdateApnsVoipSandboxChannelRequestTypeDef,
    UpdateApnsVoipSandboxChannelResponseResponseTypeDef,
    UpdateApplicationSettingsRequestTypeDef,
    UpdateApplicationSettingsResponseResponseTypeDef,
    UpdateAttributesRequestTypeDef,
    UpdateBaiduChannelRequestTypeDef,
    UpdateBaiduChannelResponseResponseTypeDef,
    UpdateCampaignRequestTypeDef,
    UpdateCampaignResponseResponseTypeDef,
    UpdateEmailChannelRequestTypeDef,
    UpdateEmailChannelResponseResponseTypeDef,
    UpdateEmailTemplateRequestTypeDef,
    UpdateEmailTemplateResponseResponseTypeDef,
    UpdateEndpointRequestTypeDef,
    UpdateEndpointResponseResponseTypeDef,
    UpdateEndpointsBatchRequestTypeDef,
    UpdateEndpointsBatchResponseResponseTypeDef,
    UpdateGcmChannelRequestTypeDef,
    UpdateGcmChannelResponseResponseTypeDef,
    UpdateJourneyRequestTypeDef,
    UpdateJourneyResponseResponseTypeDef,
    UpdateJourneyStateRequestTypeDef,
    UpdateJourneyStateResponseResponseTypeDef,
    UpdatePushTemplateRequestTypeDef,
    UpdatePushTemplateResponseResponseTypeDef,
    UpdateRecommenderConfigurationRequestTypeDef,
    UpdateRecommenderConfigurationResponseResponseTypeDef,
    UpdateRecommenderConfigurationTypeDef,
    UpdateSegmentRequestTypeDef,
    UpdateSegmentResponseResponseTypeDef,
    UpdateSmsChannelRequestTypeDef,
    UpdateSmsChannelResponseResponseTypeDef,
    UpdateSmsTemplateRequestTypeDef,
    UpdateSmsTemplateResponseResponseTypeDef,
    UpdateTemplateActiveVersionRequestTypeDef,
    UpdateTemplateActiveVersionResponseResponseTypeDef,
    UpdateVoiceChannelRequestTypeDef,
    UpdateVoiceChannelResponseResponseTypeDef,
    UpdateVoiceTemplateRequestTypeDef,
    UpdateVoiceTemplateResponseResponseTypeDef,
    VoiceChannelRequestTypeDef,
    VoiceChannelResponseTypeDef,
    VoiceMessageTypeDef,
    VoiceTemplateRequestTypeDef,
    VoiceTemplateResponseTypeDef,
    WaitActivityTypeDef,
    WaitTimeTypeDef,
    WriteApplicationSettingsRequestTypeDef,
    WriteCampaignRequestTypeDef,
    WriteEventStreamTypeDef,
    WriteJourneyRequestTypeDef,
    WriteSegmentRequestTypeDef,
    WriteTreatmentResourceTypeDef,
)

def get_structure() -> ADMChannelRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-pinpoint` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-pinpoint docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_pinpoint/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
